/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: tSerialPortMain.c 398 2009-06-10 07:15:47Z ertl-takuya $
 */

/*
 *		ꥢ륤󥿥եɥ饤
 */

#include <kernel.h>
#include <t_syslog.h>
#include "tSerialPortMain_tecsgen.h"

/*
 *  ե˴Ϣȥޥ
 */
#define	FC_STOP			'\023'		/* ȥ-S */
#define	FC_START		'\021'		/* ȥ-Q */

#define BUFCNT_STOP(bufsz)		((bufsz) * 3 / 4)	/* STOPʸ */
#define BUFCNT_START(bufsz)		((bufsz) / 2)		/* STARTʸ */

/*
 *  ݥ󥿤Υ󥯥
 */
#define INC_PTR(ptr, bufsz)		{ if (++(ptr) == (bufsz)) { (ptr) = 0; }}

/*
 *  ӥƽФޥ
 *
 *  ӥƽФޤ༰expɾͤ顼͡ˤξ
 *  ˤϡercercd_expɾͤerror_exitgoto롥
 */
#define SVC(exp, ercd_exp) \
				{ if ((exp) < 0) { ercd = (ercd_exp); goto error_exit; }}

/*
 *  E_SYS顼
 */
static ER
gen_ercd_sys(CELLCB *p_cellcb)
{
	VAR_errorflag = true;
	return(E_SYS);
}

/*
 *  Ԥ륵ӥ뤫Υ顼Ѵ
 */
static ER
gen_ercd_wait(ER rercd, CELLCB *p_cellcb)
{
	switch (MERCD(rercd)) {
	case E_RLWAI:
	case E_DLT:
		return(rercd);
	default:
		VAR_errorflag = true;
		return(E_SYS);
	}
}

/*
 *  ꥢݡȤΥץʼؿ
 */
ER
eSerialPort_open(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	ER		ercd;

	if (sns_dpn()) {				/* ƥȤΥå */
		return(E_CTX);
	}
	if (!VALID_IDX(idx)) {
		return(E_ID);				/* ݡֹΥå */
	}
	p_cellcb = GET_CELLCB(idx);

	SVC(dis_dsp(), gen_ercd_sys(p_cellcb));
	if (VAR_openflag) {				/* ץѤߤΥå */
		ercd = E_OBJ;
	}
	else {
		/*
		 *  ѿν
		 */
		VAR_ioctl = (IOCTL_ECHO | IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV);

		VAR_rcv_read_ptr = VAR_rcv_write_ptr = 0U;
		VAR_rcv_count = 0U;
		VAR_rcv_fc_chr = '\0';
		VAR_rcv_stopped = false;

		VAR_snd_read_ptr = VAR_snd_write_ptr = 0U;
		VAR_snd_count = 0U;
		VAR_snd_stopped = false;

		/*
		 *  ʹߡߤػߤ롥
		 */
		if (loc_cpu() < 0) {
			ercd = E_SYS;
			goto error_exit_enadsp;
		}

		/*
		 *  ϡɥ¸Υץ
		 */
		cSIOPort_open();

		/*
		 *  ΥХåĤ롥
		 */
		cSIOPort_enableCBR(SIO_RDY_RCV);
		VAR_openflag = true;
		VAR_errorflag = false;

		if (unl_cpu() < 0) {
			VAR_errorflag = true;
			ercd = E_SYS;
			goto error_exit_enadsp;
		}
		ercd = E_OK;
	}

  error_exit_enadsp:
	SVC(ena_dsp(), gen_ercd_sys(p_cellcb));

  error_exit:
	return(ercd);
}

/*
 *  ꥢݡȤΥʼؿ
 */
ER
eSerialPort_close(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	ER		ercd;
	bool_t	eflag = false;

	if (sns_dpn()) {				/* ƥȤΥå */
		return(E_CTX);
	}
	if (!VALID_IDX(idx)) {
		return(E_ID);				/* ݡֹΥå */
	}
	p_cellcb = GET_CELLCB(idx);

	SVC(dis_dsp(), gen_ercd_sys(p_cellcb));
	if (!VAR_openflag) {			/* ץѤߤΥå */
		ercd = E_OBJ;
	}
	else {
		/*
		 *  ϡɥ¸Υ
		 */
		if (loc_cpu() < 0) {
			eflag = true;
		}
		cSIOPort_close();
		VAR_openflag = false;
		if (unl_cpu() < 0) {
			eflag = true;
		}

		/*
		 *  ޥեν
		 */
		if (cSendSemaphore_initialize() < 0) {
			eflag = true;
		}
		if (cReceiveSemaphore_initialize() < 0) {
			eflag = true;
		}

		/*
		 *  顼ɤ
		 */
		if (eflag) {
			ercd = gen_ercd_sys(p_cellcb);
		}
		else {
			ercd = E_OK;
		}
	}
	SVC(ena_dsp(), gen_ercd_sys(p_cellcb));

  error_exit:
	return(ercd);
}

/*
 *  ꥢݡȤؤʸ
 *
 *  p_cellcbǻꤵ륷ꥢI/OݡȤФơʸc롥ʸ
 *  쥸ˤ줿ˤtrue֤Ǥʤˤϡ
 *  쥸ȤΤ륳ХåؿĤfalse
 *  δؿϡCPUå֤ǸƤӽФ롥
 */
Inline bool_t
serialPort_snd_chr(CELLCB *p_cellcb, char_t c)
{
	if (cSIOPort_putChar(c)) {
		return(true);
	}
	else {
		cSIOPort_enableCBR(SIO_RDY_SND);
		return(false);
	}
}

/*
 *  ꥢݡȤؤ1ʸ
 */
static ER_BOOL
serialPort_wri_chr(CELLCB *p_cellcb, char_t c)
{
	bool_t	buffer_full;
	ER		ercd, rercd;

	/*
	 *  LFCR롥
	 */
	if (c == '\n' && (VAR_ioctl & IOCTL_CRLF) != 0U) {
		SVC(rercd = serialPort_wri_chr(p_cellcb, '\r'), rercd);
		if ((bool_t) rercd) {
			SVC(rercd = cSendSemaphore_wait(),
										gen_ercd_wait(rercd, p_cellcb));
		}
	}

	SVC(loc_cpu(), gen_ercd_sys(p_cellcb));
	if (VAR_snd_count == 0U && !VAR_snd_stopped
								&& serialPort_snd_chr(p_cellcb, c)) {
		/*
		 *  ꥢI/OǥХ쥸ʸ뤳Ȥ
		 *  硥
		 */
		buffer_full = false;
	}
	else {
		/*
		 *  Хåեʸ롥
		 */
		VAR_snd_buffer[VAR_snd_write_ptr] = c;
		INC_PTR(VAR_snd_write_ptr, ATTR_snd_bufsz);
		p_cellcb->snd_count++;
		buffer_full = (VAR_snd_count == ATTR_snd_bufsz);
	}

	SVC(unl_cpu(), gen_ercd_sys(p_cellcb));
	ercd = (ER_BOOL) buffer_full;

  error_exit:
	return(ercd);
}

/*
 *  ꥢݡȤؤʸʼؿ
 */
ER_UINT
eSerialPort_write(CELLIDX idx, const char_t *buf, uint_t len)
{
	CELLCB	*p_cellcb;
	bool_t	buffer_full;
	uint_t	wricnt = 0U;
	ER		ercd, rercd;

	if (sns_dpn()) {				/* ƥȤΥå */
		return(E_CTX);
	}
	if (!VALID_IDX(idx)) {			/* ݡֹΥå */
		return(E_ID);
	}

	p_cellcb = GET_CELLCB(idx);
	if (!VAR_openflag) {			/* ץѤߤΥå */
		return(E_OBJ);
	}
	if (VAR_errorflag) {			/* 顼֤Υå */
		return(E_SYS);
	}

	buffer_full = true;				/* 롼פ1wai_sem */
	while (wricnt < len) {
		if (buffer_full) {
			SVC(rercd = cSendSemaphore_wait(),
										gen_ercd_wait(rercd, p_cellcb));
		}
		SVC(rercd = serialPort_wri_chr(p_cellcb, *buf++), rercd);
		wricnt++;
		buffer_full = (bool_t) rercd;
	}
	if (!buffer_full) {
		SVC(cSendSemaphore_signal(), gen_ercd_sys(p_cellcb));
	}
	ercd = E_OK;

  error_exit:
	return(wricnt > 0U ? (ER_UINT) wricnt : ercd);
}

/*
 *  ꥢݡȤ1ʸ
 */
static bool_t
serialPort_rea_chr(CELLCB *p_cellcb, char_t *p_c)
{
	bool_t	buffer_empty;
	ER		ercd;

	SVC(loc_cpu(), gen_ercd_sys(p_cellcb));

	/*
	 *  ХåեʸФ
	 */
	*p_c = VAR_rcv_buffer[VAR_rcv_read_ptr];
	INC_PTR(VAR_rcv_read_ptr, ATTR_rcv_bufsz);
	VAR_rcv_count--;
	buffer_empty = (VAR_rcv_count == 0U);

	/*
	 *  START롥
	 */
	if (VAR_rcv_stopped && VAR_rcv_count <= BUFCNT_START(ATTR_rcv_bufsz)) {
		if (!serialPort_snd_chr(p_cellcb, FC_START)) {
			VAR_rcv_fc_chr = FC_START;
		}
		VAR_rcv_stopped = false;
	}

	SVC(unl_cpu(), gen_ercd_sys(p_cellcb));
	ercd = (ER_BOOL) buffer_empty;

  error_exit:
	return(ercd);
}

/*
 *  ꥢݡȤʸʼؿ
 */
ER_UINT
eSerialPort_read(CELLIDX idx, char_t *buf, uint_t len)
{
	CELLCB	*p_cellcb;
	bool_t	buffer_empty;
	uint_t	reacnt = 0U;
	char_t	c = '\0';		/* ѥηٹ޻ߤ뤿˽ */
	ER		ercd, rercd;

	if (sns_dpn()) {				/* ƥȤΥå */
		return(E_CTX);
	}
	if (!VALID_IDX(idx)) {			/* ݡֹΥå */
		return(E_ID);
	}

	p_cellcb = GET_CELLCB(idx);
	if (!VAR_openflag) {			/* ץѤߤΥå */
		return(E_OBJ);
	}
	if (VAR_errorflag) {			/* 顼֤Υå */
		return(E_SYS);
	}

	buffer_empty = true;			/* 롼פ1wai_sem */
	while (reacnt < len) {
		if (buffer_empty) {
			SVC(rercd = cReceiveSemaphore_wait(),
										gen_ercd_wait(rercd, p_cellcb));
		}
		SVC(rercd = serialPort_rea_chr(p_cellcb, &c), rercd);
		*buf++ = c;
		reacnt++;
		buffer_empty = (bool_t) rercd;

		/*
		 *  Хå
		 */
		if ((VAR_ioctl & IOCTL_ECHO) != 0U) {
			SVC(rercd = cSendSemaphore_wait(),
										gen_ercd_wait(rercd, p_cellcb));
			SVC(rercd = serialPort_wri_chr(p_cellcb, c), rercd);
			if (!((bool_t) rercd)) {
				SVC(cSendSemaphore_signal(), gen_ercd_sys(p_cellcb));
			}
		}
	}
	if (!buffer_empty) {
		SVC(cReceiveSemaphore_signal(), gen_ercd_sys(p_cellcb));
	}
	ercd = E_OK;

  error_exit:
	return(reacnt > 0U ? (ER_UINT) reacnt : ercd);
}

/*
 *  ꥢݡȤʼؿ
 */
ER
eSerialPort_control(CELLIDX idx, uint_t ioctl)
{
	CELLCB	*p_cellcb;

	if (sns_dpn()) {				/* ƥȤΥå */
		return(E_CTX);
	}
	if (!VALID_IDX(idx)) {
		return(E_ID);				/* ݡֹΥå */
	}

	p_cellcb = GET_CELLCB(idx);
	if (!VAR_openflag) {			/* ץѤߤΥå */
		return(E_OBJ);
	}
	if (VAR_errorflag) {			/* 顼֤Υå */
		return(E_SYS);
	}

	VAR_ioctl = ioctl;
	return(E_OK);
}

/*
 *  ꥢݡȾ֤λȡʼؿ
 */
ER
eSerialPort_refer(CELLIDX idx, T_SERIAL_RPOR* pk_rpor)
{
	CELLCB	*p_cellcb;

	if (sns_dpn()) {				/* ƥȤΥå */
		return(E_CTX);
	}
	if (!VALID_IDX(idx)) {
		return(E_ID);				/* ݡֹΥå */
	}

	p_cellcb = GET_CELLCB(idx);
	if (!VAR_openflag) {			/* ץѤߤΥå */
		return(E_OBJ);
	}
	if (VAR_errorflag) {			/* 顼֤Υå */
		return(E_SYS);
	}

	pk_rpor->reacnt = VAR_rcv_count;
	pk_rpor->wricnt = VAR_snd_count;
	return(E_OK);
}

/*
 *  ꥢݡȤǽХåʼؿ
 */
void
eiSIOCBR_readySend(CELLIDX idx)
{
	CELLCB	*p_cellcb;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);
	if (VAR_rcv_fc_chr != '\0') {
		/*
		 *  START/STOP 롥
		 */
		(void) cSIOPort_putChar(VAR_rcv_fc_chr);
		VAR_rcv_fc_chr = '\0';
	}
	else if (!VAR_snd_stopped && VAR_snd_count > 0U) {
		/*
		 *  Хåե椫ʸФ롥
		 */
		(void) cSIOPort_putChar(VAR_snd_buffer[VAR_snd_read_ptr]);
		INC_PTR(VAR_snd_read_ptr, ATTR_snd_bufsz);
		if (VAR_snd_count == ATTR_snd_bufsz) {
			if (ciSendSemaphore_signal() < 0) {
				VAR_errorflag = true;
			}
		}
		VAR_snd_count--;
	}
	else {
		/*
		 *  ٤ʸʤϡǽХåػߤ롥
		 */
		cSIOPort_disableCBR(SIO_RDY_SND);
	}
}

/*
 *  ꥢݡȤμΥХåʼؿ
 */
void
eiSIOCBR_readyReceive(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	char_t	c;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);
	c = (char_t) cSIOPort_getChar();
	if ((VAR_ioctl & IOCTL_FCSND) != 0U && c == FC_STOP) {
		/*
		 *  ߤ롥ʸϤΤޤ롥
		 */
		VAR_snd_stopped = true;
	}
	else if (VAR_snd_stopped && (c == FC_START
				|| (VAR_ioctl & IOCTL_FCANY) != 0U)) {
		/*
		 *  Ƴ롥
		 */
		VAR_snd_stopped = false;
		if (VAR_snd_count > 0U) {
			c = VAR_snd_buffer[VAR_snd_read_ptr];
			if (serialPort_snd_chr(p_cellcb, c)) {
				INC_PTR(VAR_snd_read_ptr, ATTR_snd_bufsz);
				if (VAR_snd_count == ATTR_snd_bufsz) {
					if (ciSendSemaphore_signal() < 0) {
						VAR_errorflag = true;
					}
				}
				VAR_snd_count--;
			}
		}
	}
	else if ((VAR_ioctl & IOCTL_FCSND) != 0U && c == FC_START) {
		/*
		 *  Фƥե椷Ƥ硤START ϼΤƤ롥
		 */
	}
	else if (VAR_rcv_count == ATTR_rcv_bufsz) {
		/*
		 *  Хåեեξ硤ʸΤƤ롥
		 */
	}
	else {
		/*
		 *  ʸХåե롥
		 */
		VAR_rcv_buffer[VAR_rcv_write_ptr] = c;
		INC_PTR(VAR_rcv_write_ptr, ATTR_rcv_bufsz);
		if (VAR_rcv_count == 0U) {
			if (ciReceiveSemaphore_signal() < 0) {
				VAR_errorflag = true;
			}
		}
		VAR_rcv_count++;

		/*
		 *  STOP롥
		 */
		if ((VAR_ioctl & IOCTL_FCRCV) != 0U && !VAR_rcv_stopped
						&& VAR_rcv_count >= BUFCNT_STOP(ATTR_rcv_bufsz)) {
			if (!serialPort_snd_chr(p_cellcb, FC_STOP)) {
				VAR_rcv_fc_chr = FC_STOP;
			}
			VAR_rcv_stopped = true;
		}
	}
}

/*
 *  ꥢ륤󥿥եɥ饤Ф̤ʸμФ
 */
bool_t
enSerialPort_getChar(CELLIDX idx, char_t *p_c)
{
	CELLCB	*p_cellcb;

	if (VALID_IDX(idx)) {						/* ݡֹΥå */
		p_cellcb = GET_CELLCB(idx);
		if (VAR_openflag) {						/* ץѤߤΥå */
			if (VAR_snd_count > 0U) {
				*p_c = VAR_snd_buffer[VAR_snd_read_ptr];
				INC_PTR(VAR_snd_read_ptr, ATTR_snd_bufsz);
				VAR_snd_count--;
				return(true);
			}
		}
	}
	return(false);
}
