#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: syntaxobj.rb 84 2008-05-04 14:19:09Z okuma-top $
#++

# mikan ruby  symbol ʸλȤʬɤƤ⤦ޤʤȤΤ name.to_sym 뤳Ȥˤ

class NamedList
#  @names:: {} of items
#  @items:: [] of items : item CLASS  get_name ᥽åɤĤ, clone_for_composite ϡɬ
#  @type:: string	顼å

  def initialize( item, type )
    @names = {}
    @items = []
    @type = type
    add_item( item )
  end

  def add_item( item )

    if item then
      name = item.get_name.to_sym
      if @names[name] then
        Generator.error( "'#{name}' duplicate #{@type}" )
        return self
      end

      @names[name]=item
      @items << item
    end

    return self
  end

  def change_item( item )
    name = item.get_name.to_sym

    prev_one = @names[name]
    @names[name]=item

    @items = @items - [ prev_one ]
    @items << item
  end

  def get_item( name )
    if name then
      return @names[name.to_sym]
    else
      return nil
    end
  end

  def get_items
    return @items
  end

  # composite cell  clone (JOIN)  clone 
  def clone_for_composite
    cl = self.clone
    cl.set_clone
    return cl
  end

  # clone 줿 NamedList 󥹥󥹤λȤΤ clone
  def set_clone
    items = []
    names = {}
    @items.each { |i|
      cl = i.clone_for_composite
      names[cl.get_name] = cl
      items << cl
    }
    @items = items
    @names = names
  end

  def show_tree( indent )
    @items.each { |i|
      i.show_tree( indent )
    }
  end

end

class Typedef
# @declarator:: Decl

  def self.new_decl_list( type_spec_qual_list, decl_list )
    decl_list.each { |decl|
       Typedef.new( type_spec_qual_list, decl )
    }
  end

  def initialize( type_spec_qual_list, decl )
    decl.set_type( type_spec_qual_list )
    @declarator = decl

    Namespace.new_typedef( self )

  end

  def get_name
    @declarator.get_name

  end

  def get_declarator
    @declarator
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Typedef:"
    @declarator.show_tree( indent + 1 )
  end
end



class FuncHead
#  @declarator:: Decl

  def initialize( declarator, type, async )
    declarator.set_type( type )
    @declarator = declarator
    if type.kind_of?( FuncType ) then
      type.set_async( async )
    end
  end

  def get_name
    @declarator.get_name
  end

  def get_declarator
    @declarator
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "FuncHead:"
    @declarator.show_tree( indent + 1 )
  end
end

#=== 
# @kind ǼƼ
class Decl

# @identifer:: string
# @type:: ArrayType, FuncType, PtrType, IntType, StructType
#         VoidType, FloatType, DefinedType, BoolType
# @initializer:: constant_expression, mikan { initlist }
# @kind:: :VAR, :ATTRIBUTE, :PARAMETER, :TYPEDEF, :CONSTANT, :MEMBER
# @rw:: bool
# @omit:: bool
# @size_is:: Expression or nil unless specified

  def initialize( identifier )
    @identifier = identifier
    @rw = false
    @omit = false
    @size_is = nil
  end

  attr_reader :type, :identifier

  def set_initializer( initializer )
    @initializer = initializer
  end

  def get_initializer
    @initializer
  end

  def is_function?
    if @type.class == FuncType then
      return true
    else
      return false
    end
  end

  def check	# ̣Ū꤬Сʸ֤
    res = @type.check
    return res if res

    if @initializer then
      if @kind == :PARAMETER then
        return "#{@identifier}: parameter cannot have initializer"
      elsif @kind == :TYPEDEF then
        return "#{@identifier}: type cannot have initializer"
      else
        return @type.check_init( @initializer, @kind )
      end
    end

    return nil
  end

  def get_ptr_level
    level = 0
    type = @type
    while 1
      if type.kind_of?( PtrType ) then
        level += 1
        type = type.get_referto
      elsif type.kind_of?( ArrayType ) then  # źʤϥݥ󥿤Ȥߤʤ
        if type.get_subscript == nil then
          level += 1
          type = type.type
        else
          break
        end
        # mikan ݥ󥿤źΥݥ󥿥٥ϣǤ褤
      elsif type.kind_of?( DefinedType ) then
        type = type.get_type
        # p "DefinedType: #{type}"
      else
        break
      end
    end
    return level
  end

  def get_name
    @identifier
  end

  def set_type( type )
    unless @type then
      @type = type
    else
      @type.set_type( type )             # դ
    end
  end

  def get_type
    @type
  end

  def set_kind( kind )
    @kind = kind
  end

  def get_kind
    @kind
  end

  def set_specifier( spec )
    case spec[0]
    when :RW
      @rw = true
    when :OMIT
      @omit = true
    when :SIZE_IS
      @size_is = spec[1]
    end
  end

  def is_rw?
    @rw
  end

  def is_omit?
    @omit
  end

  def get_size_is
    @size_is
  end

  def is_type?( type )
    t = @type
    while 1
      if t.kind_of?( type ) then
        return true
      elsif t.kind_of?( DefinedType ) then
        t = t.get_type
      else
        return false
      end
    end
  end

  def is_const?
    type = @type
    while 1
      if type.is_const? then
        return true
      elsif type.kind_of?( DefinedType ) then
        type = type.get_type
      else
        return false
      end
    end
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Declarator: name: #{@identifier}  kind: #{@kind}"
    (indent+1).times { print "  " }
    puts "type:"
    @type.show_tree( indent + 2 )
    if @initializer then
      (indent+1).times { print "  " }
      puts "initializer:"
      @initializer.show_tree( indent + 2 )
    else
      (indent+1).times { print "  " }
      puts "initializer: no"
    end
   
  end

end

# ؿѥ᡼
class ParamDecl

# @declarator:: Token, ArrayType, FuncType, PtrType
# @direction:: :IN, :OUT, :INOUT, :SEND, :RECEIVE
# @size:: Expr   (size_is )
# @count:: Expr   (count_is )
# @string:: Expr or -1(if size not specified) string 
# @allocator:: Signature of allocator
#
# 1. ؿǤʤ
# 2. ʾǤäƺǤ¦ʳź뤳
# 3. in, out, ..., size_is, count_is, ... νʣ꤬ʤ
# 4. ݥ󥿥٥뤬Ŭڤʤ

  def initialize( declarator, specifier, param_specifier )
    @declarator = declarator
    @declarator.set_type( specifier )
    @param_specifier = param_specifier

    if @declarator.is_function? then		# (1)
      Generator.error( "'#{get_name}' function" )
      return
    end

    res = @declarator.check
    if res then					# (2)
      Generator.error( "'#{get_name}' #{res}" )
      return
    end

    @param_specifier.each { |i|
      case i[0]                                     # (3)
      when :IN, :OUT, :INOUT, :SEND, :RECEIVE
        if @direction == nil then
          @direction = i[0]
        elsif i[0] == @direction then
          Generator.warning( "#{i[0]}: duplicate" )
          next
        else
          Generator.error( "#{i[0]}: inconsitent with previous one" )
          next
        end

        case i[0]
        when :SEND, :RECEIVE
        # mikan allocator  signature  path бƤʤ
#          @allocator = Namespace.find( i[1] )
          @allocator = Namespace.find( [ i[1] ] )
          unless @allocator.instance_of?( Signature ) then
            Generator.error( "#{i[1]}: not found or not signature" )
            next
          end
        end

      when :SIZE_IS
        if @size then
          Generator.error( "size_is duplicate" )
        else
          @size = i[1]
        end
      when :COUNT_IS
        if @count then
          Generator.error( "count_is duplicate" )
        else
          @count = i[1]
        end
      when :STRING
        if @string then
          Generator.error( "string duplicate" )
        elsif i[1] then
          @string = i[1]
        else
          @string = -1
        end
      end

    }

    # mikan ݥ󥿤źͭˤΥ٥뤬
    ptr_level = @declarator.get_ptr_level

    # p "ptr_level: #{@declarator.identifier} #{ptr_level}"
    # p @declarator

    if !(@size||@count||@string) then	    # (4)
      req_level = 1
    elsif (@size||@count)&&@string then
      req_level = 2
    else
      req_level = 1
    end

    if @direction == :RECEIVE then
      req_level += 1
    end

    # p "req_level: #{req_level} ptr_level: #{ptr_level}"
    if ptr_level < req_level && ! ( @direction == :IN && req_level == 1 && ptr_level == 0) then
      Generator.error( "#{@declarator.identifier} need pointer or more pointer" )
    elsif ptr_level > req_level then
      Generator.warning( "#{@declarator.identifier} pointer level mismatch" )
    end

    type = @declarator.get_type
    while type.kind_of?( DefinedType )
      type = type.get_original_type
    end

    if ptr_level > 0 then
      type.set_scs( @size, @count, @string )
    end

    # p self

  end

  def get_name
    @declarator.get_name
  end

  def get_size
    @size
  end

  def get_count
    @count
  end

  def get_string
    @string
  end

  def get_type
    @declarator.get_type
  end

  def get_direction
    @direction
  end

  def get_declarator
    @declarator
  end

  def get_allocator
    @allocator
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "ParamDecl: direction: #{@direction}"
    @declarator.show_tree( indent + 1 )
    if @size then
      (indent+1).times { print "  " }
      puts "size:"
      @size.show_tree( indent + 2 )
    end
    if @count then
      (indent+1).times { print "  " }
      puts "count:"
      @count.show_tree( indent + 2 )
    end
    if @string then
      (indent+1).times { print "  " }
      puts "string:"
      if @string == -1 then
       (indent+2).times { print "  " }
        puts "size is not specified"
      else
        @string.show_tree( indent + 2 )
      end
    end
    if @allocator then
      (indent+1).times { print "  " }
      puts "allocator:"
      (indent+2).times { print "  " }
        puts allocator
    end    
  end
end

# ؿѥ᡼ꥹ
class ParamList
# @param_list:: NamedList : item: ParamDecl

  def initialize( paramdecl )
    @param_list = NamedList.new( paramdecl, "parameter" )
  end

  def add_param( paramdecl )
    @param_list.add_item( paramdecl )
  end

  def get_items
    @param_list.get_items
  end

  #=== size_is, count_is, string ΰμå
  # ѿȲǽʤᡢؿƬιʸ᤬ä˥å
  def check_param
    @param_list.get_items.each { |i|
      next if i == nil                      # i == nil : 顼

      size = i.get_size			# Expression
      if size then
        val = size.eval_const( @param_list )
        if val == nil then			# Ǥʤ
          # mikan ѿޤ༰ñѿΤ OK
          type = size.get_type( @param_list )
          unless type.kind_of?( IntType ) then
            Generator.error( "size_is argument is not integer type" )
          else
            size.check_dir_for_param( @param_list, i.get_direction, "size_is" )
          end
        else
          # mikan Υåʷ̤ʤOKȤƤ
          if val != Integer( val ) then
            Generator.error( "'#{i.get_declarator.identifier}' size_is parameter not integer" )
          elsif val <= 0 then
            Generator.error( "'#{i.get_declarator.identifier}' size_is parameter negative or zero" )
          end
        end
      end


      count = i.get_count			# Expression
      if count then
        val = count.eval_const( @param_list )
        if val == nil then			# Ǥʤ
          # mikan ѿޤ༰ñѿΤ OK
          type = count.get_type( @param_list )
          unless type.kind_of?( IntType ) then
            Generator.error( "count_is argument is not integer type" )
          else
            count.check_dir_for_param( @param_list, i.get_direction, "count_is" )
          end
        else
          # mikan Υåʷ̤ʤOKȤƤ
          if val != Integer( val ) then
            Generator.error( "'#{i.get_declarator.identifier}' count_is parameter not integer" )
          elsif val <= 0 then
            Generator.error( "'#{i.get_declarator.identifier}' count_is parameter negative or zero" )
          end
        end
      end

      string = i.get_string			# Expression
      if string != -1 && string then
        val = string.eval_const( @param_list )
        if val == nil then			# Ǥʤ
          # mikan ѿޤ༰ñѿΤ OK
          type = string.get_type( @param_list )
          unless type.kind_of?( IntType ) then
            Generator.error( "string argument is not integer type" )
          else
            string.check_dir_for_param( @param_list, i.get_direction, "string" )
          end
        else
          # mikan Υåʷ̤ʤOKȤƤ
          if val != Integer( val ) then
            Generator.error( "'#{i.get_declarator.identifier}' string parameter not integer" )
          elsif val <= 0 then
            Generator.error( "'#{i.get_declarator.identifier}' string parameter negative or zero" )
          end
        end
      end
    }
  end

  def find( name )
    @param_list.get_item( name )
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "ParamList:"
    @param_list.show_tree( indent + 1 )
  end
end

